/***
   NAME
     ebtutils.h
   PURPOSE
     Interface header file to the functions defined in ebtutils.c
   NOTES
     
   HISTORY
     AMdR - Jul 19, 1995 : Created.
     AMdR - Apr 05, 2011 : Revised last.
***/

/*==========================================================================*/
#ifndef EBTUTILS_H
#define EBTUTILS_H

#ifdef	EBTUTILS_C
#undef	EXTERN
#define EXTERN
#else
#undef	EXTERN
#define EXTERN	extern
#endif
EXTERN int	imin(PROTO2(int, int));
EXTERN int	imax(PROTO2(int, int));
EXTERN double	min(PROTO2(double, double));
EXTERN double	max(PROTO2(double, double));
EXTERN int	iszero(PROTO1(double));
EXTERN int	isequal(PROTO2(double, double));
EXTERN void	SetStepSize(PROTO1(double));
EXTERN void	ErrorAbort(PROTO1(const char *));
EXTERN void	ErrorExit(PROTO2(const int, const char *));
EXTERN void	Warning(PROTO1(const char *));
EXTERN void     FileOut(PROTO1(void));
EXTERN void     FileState(PROTO1(void));
EXTERN void	*Myalloc(PROTO3(void *, size_t, size_t));
EXTERN void	PrettyPrint(PROTO2(FILE *fp, double output));
EXTERN void	WriteStateToFile(PROTO2(FILE *fp, double *data));
EXTERN void	kill_shmem(PROTO1(void));
EXTERN int	init_shmem(PROTO1(void));
#if ANSI_C
EXTERN void	ReportNote(PROTO2(const char *, ...));
#endif /* ANSI_C */
#if (BIFURCATION == 1)
EXTERN void	SetBifOutputTimes(PROTO1(double *));
#if (MEASUREBIFSTATS == 1)
EXTERN void	outputMeasureBifstats(PROTO1(double *env));
#if ANSI_C
EXTERN void	measureBifstats(PROTO4(double *env, population *pop, int Nstores, ...));
#endif
#endif
#endif // (BIFURCATION == 1)


/*==========================================================================*/
#endif /* EBTUTILS_H */
